2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by at least coreutils, idutils, CPPI, Bison, and Autoconf.
5 ## Copyright (C) 2001-2008 Free Software Foundation, Inc.
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 ## GNU General Public License for more details.
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program. If not, see <http://www.gnu.org/licenses/>.
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
24 # Do not save the original name or timestamp in the .tar.gz file.
25 # Use --rsyncable if available.
27 $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null && echo --rsyncable)
28 GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
32 VC-tag = git tag -s -m '$(VERSION)'
34 VC_LIST = build-aux/vc-list-files
37 $(VC_LIST) | if test -f .x-$@; then grep -vEf .x-$@; else grep -v ChangeLog; fi
39 ifeq ($(origin prev_version_file), undefined)
40 prev_version_file = $(srcdir)/.prev-version
43 PREV_VERSION := $(shell cat $(prev_version_file))
44 VERSION_REGEXP = $(subst .,\.,$(VERSION))
45 PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
48 this-vc-tag = v$(VERSION)
49 this-vc-tag-regexp = v$(VERSION_REGEXP)
51 tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
52 tag-this-version = $(subst .,_,$(VERSION))
53 this-vc-tag = $(tag-package)-$(tag-this-version)
54 this-vc-tag-regexp = $(this-vc-tag)
56 my_distdir = $(PACKAGE)-$(VERSION)
58 # Old releases are stored here.
59 release_archive_dir ?= ../release
61 # Prevent programs like 'sort' from considering distinct strings to be equal.
62 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
71 # Collect the names of rules starting with `sc_'.
72 syntax-check-rules := $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
74 .PHONY: $(syntax-check-rules)
76 local-checks-available = \
77 po-check copyright-check m4-check author_mark_check \
78 patch-check strftime-check $(syntax-check-rules) \
79 makefile_path_separator_check \
80 makefile-check check-AUTHORS
81 .PHONY: $(local-checks-available)
83 local-check := $(filter-out $(local-checks-to-skip), $(local-checks-available))
85 syntax-check: $(local-check)
86 # @grep -nE '# *include <(limits|std(def|arg|bool))\.h>' \
87 # $$(find -type f -name '*.[chly]') && \
88 # { echo '$(ME): found conditional include' 1>&2; \
91 # grep -nE '^# *include <(string|stdlib)\.h>' \
92 # $(srcdir)/{lib,src}/*.[chy] && \
93 # { echo '$(ME): FIXME' 1>&2; \
95 # FIXME: don't allow `#include .strings\.h' anywhere
97 sc_avoid_if_before_free:
98 @$(srcdir)/build-aux/useless-if-before-free \
99 $(useless_free_options) \
100 $$($(VC_LIST_EXCEPT)) && \
101 { echo '$(ME): found useless "if" before "free" above' 1>&2; \
104 sc_cast_of_argument_to_free:
105 @grep -nE '\<free *\( *\(' $$($(VC_LIST_EXCEPT)) && \
106 { echo '$(ME): don'\''t cast free argument' 1>&2; \
109 sc_cast_of_x_alloc_return_value:
110 @grep -nE '\*\) *x(m|c|re)alloc\>' $$($(VC_LIST_EXCEPT)) && \
111 { echo '$(ME): don'\''t cast x*alloc return value' 1>&2; \
114 sc_cast_of_alloca_return_value:
115 @grep -nE '\*\) *alloca\>' $$($(VC_LIST_EXCEPT)) && \
116 { echo '$(ME): don'\''t cast alloca return value' 1>&2; \
120 @grep -n '[ ] ' $$($(VC_LIST_EXCEPT)) && \
121 { echo '$(ME): found SPACE-TAB sequence; remove the SPACE' \
124 # Don't use *scanf or the old ato* functions in `real' code.
125 # They provide no error checking mechanism.
126 # Instead, use strto* functions.
127 sc_prohibit_atoi_atof:
128 @grep -nE '\<([fs]?scanf|ato([filq]|ll))\>' $$($(VC_LIST_EXCEPT)) && \
129 { echo '$(ME): do not use *scan''f, ato''f, ato''i, ato''l, ato''ll, ato''q, or ss''canf' \
132 # Use STREQ rather than comparing strcmp == 0, or != 0.
134 @grep -nE '! *str''cmp *\(|\<str''cmp *\([^)]+\) *==' \
135 $$($(VC_LIST_EXCEPT)) && \
136 { echo '$(ME): use STREQ in place of the above uses of str''cmp' \
139 # Using EXIT_SUCCESS as the first argument to error is misleading,
140 # since when that parameter is 0, error does not exit. Use `0' instead.
141 sc_error_exit_success:
142 @grep -nF 'error (EXIT_SUCCESS,' \
143 $$(find -type f -name '*.[chly]') && \
144 { echo '$(ME): found error (EXIT_SUCCESS' 1>&2; \
147 # `FATAL:' should be fully upper-cased in error messages
148 # `WARNING:' should be fully upper-cased, or fully lower-cased
149 sc_error_message_warn_fatal:
150 @grep -nEA2 '[^rp]error \(' $$($(VC_LIST_EXCEPT)) \
151 | grep -E '"Warning|"Fatal|"fatal' && \
152 { echo '$(ME): use FATAL, WARNING or warning' 1>&2; \
155 # Error messages should not start with a capital letter
156 sc_error_message_uppercase:
157 @grep -nEA2 '[^rp]error \(' $$($(VC_LIST_EXCEPT)) \
159 | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' && \
160 { echo '$(ME): found capitalized error message' 1>&2; \
163 # Error messages should not end with a period
164 sc_error_message_period:
165 @grep -nEA2 '[^rp]error \(' $$($(VC_LIST_EXCEPT)) \
166 | grep -E '[^."]\."' && \
167 { echo '$(ME): found error message ending in period' 1>&2; \
171 @grep -ni 'file''system' $$($(VC_LIST_EXCEPT)) && \
172 { echo '$(ME): found use of "file''system";' \
173 'rewrite to use "file system"' 1>&2; \
176 # Don't use cpp tests of this symbol. All code assumes config.h is included.
178 @grep -n '^# *if.*HAVE''_CONFIG_H' $$($(VC_LIST_EXCEPT)) && \
179 { echo '$(ME): found use of HAVE''_CONFIG_H; remove' \
182 # Nearly all .c files must include <config.h>.
184 @if $(VC_LIST_EXCEPT) | grep '\.c$$' > /dev/null; then \
185 grep -L '^# *include <config\.h>' \
186 $$($(VC_LIST_EXCEPT) | grep '\.c$$') \
188 { echo '$(ME): the above files do not include <config.h>' \
189 1>&2; exit 1; } || :; \
193 # To use this "command" macro, you must first define two shell variables:
194 # h: the header, enclosed in <> or ""
195 # re: a regular expression that matches IFF something provided by $h is used.
196 define _header_without_use
197 h_esc=`echo "$$h"|sed 's/\./\\./'`; \
198 if $(VC_LIST_EXCEPT) | grep '\.c$$' > /dev/null; then \
199 files=$$(grep -l '^# *include '"$$h_esc" \
200 $$($(VC_LIST_EXCEPT) | grep '\.c$$')) && \
201 grep -LE "$$re" $$files | grep . && \
202 { echo "$(ME): the above files include $$h but don't use it" \
203 1>&2; exit 1; } || :; \
208 # Prohibit the inclusion of assert.h without an actual use of assert.
209 sc_prohibit_assert_without_use:
210 @h='<assert.h>' re='\<assert *\(' $(_header_without_use)
212 # Prohibit the inclusion of getopt.h without an actual use.
213 sc_prohibit_getopt_without_use:
214 @h='<getopt.h>' re='\<getopt(_long)? *\(' $(_header_without_use)
216 # Don't include quotearg.h unless you use one of its functions.
217 sc_prohibit_quotearg_without_use:
218 @h='"quotearg.h"' re='\<quotearg(_[^ ]+)? *\(' $(_header_without_use)
220 # Don't include quote.h unless you use one of its functions.
221 sc_prohibit_quote_without_use:
222 @h='"quote.h"' re='\<quote(_n)? *\(' $(_header_without_use)
224 # Don't include this header unless you use one of its functions.
225 sc_prohibit_long_options_without_use:
226 @h='"long-options.h"' re='\<parse_long_options *\(' \
227 $(_header_without_use)
229 # Don't include this header unless you use one of its functions.
230 sc_prohibit_inttostr_without_use:
231 @h='"inttostr.h"' re='\<(off|[iu]max|uint)tostr *\(' \
232 $(_header_without_use)
234 # Don't include this header unless you use one of its functions.
235 sc_prohibit_error_without_use:
237 re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
238 $(_header_without_use)
240 sc_prohibit_safe_read_without_use:
241 @h='"safe-read.h"' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
242 $(_header_without_use)
244 sc_prohibit_argmatch_without_use:
246 re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<argmatch(_exit_fn|_(in)?valid) *\()' \
247 $(_header_without_use)
249 sc_prohibit_root_dev_ino_without_use:
250 @h='"root-dev-ino.h"' \
251 re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
252 $(_header_without_use)
255 @grep -nE '\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \
256 $$($(VC_LIST_EXCEPT)) && \
257 { echo '$(ME): do not use HAVE''_FCNTL_H or O''_NDELAY' \
260 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
262 # Each nonempty line must start with a year number, or a TAB.
264 @grep -n '^[^12 ]' $$(find . -maxdepth 2 -name ChangeLog) && \
265 { echo '$(ME): found unexpected prefix in a ChangeLog' 1>&2; \
268 # Ensure that dd's definition of LONGEST_SYMBOL stays in sync
269 # with the strings from the two affected variables.
270 dd_c = $(srcdir)/src/dd.c
271 sc_dd_max_sym_length:
272 ifneq ($(wildcard $(dd_c)),)
273 @len=$$( (sed -n '/conversions\[\] =$$/,/^};/p' $(dd_c);\
274 sed -n '/flags\[\] =$$/,/^};/p' $(dd_c) ) \
275 |sed -n '/"/s/^[^"]*"\([^"]*\)".*/\1/p' \
276 | wc --max-line-length); \
277 max=$$(sed -n '/^#define LONGEST_SYMBOL /s///p' $(dd_c) \
278 |tr -d '"' | wc --max-line-length); \
279 if test "$$len" = "$$max"; then :; else \
280 echo 'dd.c: LONGEST_SYMBOL is not longest' 1>&2; \
285 # Many m4 macros names once began with `jm_'.
286 # On 2004-04-13, they were all changed to start with gl_ instead.
287 # Make sure that none are inadvertently reintroduced.
288 sc_prohibit_jm_in_m4:
289 @grep -nE 'jm_[A-Z]' \
290 $$($(VC_LIST) m4 |grep '\.m4$$'; echo /dev/null) && \
291 { echo '$(ME): do not use jm_ in m4 macro names' \
294 # Ensure that each root-requiring test is run via the "check-root" rule.
297 && grep check-root tests/Makefile.am>/dev/null 2>&1; then \
298 t1=sc-root.expected; t2=sc-root.actual; \
299 grep -nl '^require_root_$$' \
300 $$($(VC_LIST) tests) |sed s,tests/,, |sort > $$t1; \
301 sed -n '/^root_tests =[ ]*\\$$/,/[^\]$$/p' \
302 $(srcdir)/tests/Makefile.am \
303 | sed 's/^ *//;/^root_tests =/d' \
304 | tr -s '\012\\' ' ' | fmt -1 | sort > $$t2; \
305 diff -u $$t1 $$t2 || diff=1; \
308 && { echo 'tests/Makefile.am: missing check-root action'>&2; \
312 headers_with_interesting_macro_defs = \
323 # Create a list of regular expressions matching the names
324 # of macros that are guaranteed by parts of gnulib to be defined.
326 @(cd $(srcdir)/lib; \
327 for f in $(headers_with_interesting_macro_defs); do \
329 sed -n '/^# *define \([^_ (][^ (]*\)[ (].*/s//\1/p' $$f; \
332 | grep -Ev 'ATTRIBUTE_NORETURN|SIZE_MAX' \
333 | sed 's/^/^# *define /' \
337 # Don't define macros that we already get from gnulib header files.
338 sc_always_defined_macros: .re-defmac
339 @if test -f $(srcdir)/src/system.h; then \
340 trap 'rc=$$?; rm -f .re-defmac; exit $$rc' 0 1 2 3 15; \
341 grep -f .re-defmac $$($(VC_LIST)) \
342 && { echo '$(ME): define the above via some gnulib .h file' \
343 1>&2; exit 1; } || :; \
346 # Create a list of regular expressions matching the names
347 # of files included from system.h. Exclude a couple.
349 @sed -n '/^# *include /s///p' $(srcdir)/src/system.h \
350 | grep -Ev 'sys/(param|file)\.h' \
351 | sed 's/ .*//;;s/^["<]/^# *include [<"]/;s/\.h[">]$$/\\.h[">]/' \
355 # Files in src/ should not include directly any of
356 # the headers already included via system.h.
357 sc_system_h_headers: .re-list
358 @if test -f $(srcdir)/src/system.h; then \
359 trap 'rc=$$?; rm -f .re-list; exit $$rc' 0 1 2 3 15; \
360 grep -nE -f .re-list \
361 $$($(VC_LIST) src | \
362 grep -Ev '((copy|system)\.h|parse-gram\.c)$$') \
363 && { echo '$(ME): the above are already included via system.h'\
364 1>&2; exit 1; } || :; \
367 # Ensure that each .c file containing a "main" function also
368 # calls set_program_name.
370 @if $(VC_LIST_EXCEPT) | grep '\.c$$' > /dev/null; then \
371 files=$$(grep -l '^main *(' $$($(VC_LIST_EXCEPT) | grep '\.c$$')); \
372 grep -LE 'set_program_name *\(m?argv\[0\]\);' $$files \
374 { echo '$(ME): the above files do not call set_program_name' \
375 1>&2; exit 1; } || :; \
379 # Require that the final line of each test-lib.sh-using test be this one:
380 # (exit $fail); exit $fail
381 # Note: this test requires GNU grep's --label= option.
382 sc_require_test_exit_idiom:
383 @if test -f $(srcdir)/tests/test-lib.sh; then \
385 for i in $$(grep -l -F /../test-lib.sh $$($(VC_LIST) tests)); do \
386 tail -n1 $$i | grep '^(exit \$$fail); exit \$$fail$$' > /dev/null \
387 && : || { die=1; echo $$i; } \
390 { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
391 echo 1>&2 '(exit $$fail); exit $$fail'; \
397 'solaris[^[:alnum:]]*2\.(7|8|9|[1-9][0-9])|sunos[^[:alnum:]][6-9]' \
398 $$($(VC_LIST_EXCEPT)) && \
399 { echo '$(ME): found misuse of Sun OS version numbers' 1>&2; \
403 @grep -ni '\<the ''the\>' $$($(VC_LIST_EXCEPT)) && \
404 { echo '$(ME): found use of "the ''the";' 1>&2; \
411 @grep -n '[ ]$$' $$($(VC_LIST_EXCEPT)) && \
412 { echo '$(ME): found trailing blank(s)' \
415 # Match lines like the following, but where there is only one space
416 # between the options and the description:
417 # -D, --all-repeated[=delimit-method] print all duplicate lines\n
418 longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
419 sc_two_space_separator_in_usage:
420 @grep -nE '^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \
421 $$($(VC_LIST_EXCEPT)) && \
422 { echo "$(ME): help2man requires at least two spaces between"; \
423 echo "$(ME): an option and its description"; \
426 # Look for diagnostics that aren't marked for translation.
427 # This won't find any for which error's format string is on a separate line.
428 sc_unmarked_diagnostics:
430 '\<error \([^"]*"[^"]*[a-z]{3}' $$($(VC_LIST_EXCEPT)) \
431 | grep -v '_''(' && \
432 { echo '$(ME): found unmarked diagnostic(s)' 1>&2; \
435 # Avoid useless parentheses like those in this example:
436 # #if defined (SYMBOL) || defined (SYM2)
437 sc_useless_cpp_parens:
438 @grep -n '^# *if .*defined *(' $$($(VC_LIST_EXCEPT)) && \
439 { echo '$(ME): found useless parentheses in cpp directive' \
442 # Require the latest GPL.
444 @grep -n 'either ''version [^3]' $$($(VC_LIST_EXCEPT)) && \
445 { echo '$(ME): GPL vN, N!=3' 1>&2; exit 1; } || :
447 # Perl-based tests used to exec perl from a #!/bin/sh script.
448 # Now they all start with #!/usr/bin/perl and the portability
449 # infrastructure is in tests/Makefile.am. Make sure no old-style
450 # script sneaks back in.
451 sc_no_exec_perl_coreutils:
452 @if test -f $(srcdir)/tests/Coreutils.pm; then \
453 grep '^exec *\$$PERL.*MCoreutils' $$($(VC_LIST) tests) && \
454 { echo 1>&2 '$(ME): found anachronistic Perl-based tests'; \
459 $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
460 $(srcdir)/NEWS | md5sum -)
462 # Ensure that we don't accidentally insert an entry into an old NEWS block.
464 @if test -f $(srcdir)/NEWS; then \
465 test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : || \
466 { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
469 # Update the hash stored above. Do this after each release and
470 # for any corrections to old entries.
471 update-NEWS-hash: NEWS
472 perl -pi -e 's/^(old_NEWS_hash = ).*/$${1}'"$(NEWS_hash)/" \
475 epoch_date = 1970-01-01 00:00:00.000000000 +0000
476 # Ensure that the c99-to-c89 patch applies cleanly.
478 rm -rf src-c89 $@.1 $@.2
480 (cd src-c89; patch -p1 -V never --fuzz=0) < src/c99-to-c89.diff \
482 if test "$(REGEN_PATCH)" = yes; then \
483 diff -upr src src-c89 | sed 's,src-c89/,src/,' \
484 | grep -vE '^(Only in|File )' \
485 | perl -pe 's/^((?:\+\+\+|---) \S+\t).*/$${1}$(epoch_date)/' \
487 grep -v '^patching file ' $@.1 > $@.2 || :
488 msg=ok; test -s $@.2 && msg='fuzzy patch' || : ; \
489 rm -f src-c89/*.o || msg='rm failed'; \
490 $(MAKE) -C src-c89 CFLAGS='-Wdeclaration-after-statement -Werror' \
491 || msg='compile failure with extra options'; \
492 test "$$msg" = ok && rm -rf src-c89 $@.1 $@.2 || echo "$$msg" 1>&2; \
495 # Ensure that date's --help output stays in sync with the info
496 # documentation for GNU strftime. The only exception is %N,
497 # which date accepts but GNU strftime does not.
498 extract_char = sed 's/^[^%][^%]*%\(.\).*/\1/'
500 if test -f $(srcdir)/src/date.c; then \
501 grep '^ %. ' $(srcdir)/src/date.c | sort \
502 | $(extract_char) > $@-src; \
504 info libc date calendar format | grep '^ `%.'\' \
505 | $(extract_char); } | sort > $@-info; \
506 diff -u $@-src $@-info || exit 1; \
507 rm -f $@-src $@-info; \
513 # Ensure that we use only the standard $(VAR) notation,
514 # not @...@ in Makefile.am, now that we can rely on automake
515 # to emit a definition for each substituted variable.
517 grep -nE '@[A-Z_0-9]+@' `find . -name Makefile.am` \
518 && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
520 news-date-check: NEWS
521 today=`date +%Y-%m-%d`; \
522 if head NEWS | grep '^\*.* $(VERSION_REGEXP) ('$$today')' \
526 echo "version or today's date is not in NEWS" 1>&2; \
531 if head ChangeLog | grep 'Version $(VERSION_REGEXP)\.$$' \
535 echo "$(VERSION) not in ChangeLog" 1>&2; \
540 @grep -n 'AC_DEFUN([^[]' m4/*.m4 \
541 && { echo '$(ME): quote the first arg to AC_DEFUN' 1>&2; \
544 # Verify that all source files using _() are listed in po/POTFILES.in.
545 # FIXME: don't hard-code file names below; use a more general mechanism.
547 if test -f po/POTFILES.in; then \
548 grep -E -v '^(#|$$)' po/POTFILES.in \
549 | grep -v '^src/false\.c$$' | sort > $@-1; \
551 for file in $$($(VC_LIST_EXCEPT)) lib/*.[ch]; do \
553 djgpp/* | man/*) continue;; \
554 */c99-to-c89.diff) continue;; \
558 base=`expr " $$file" : ' \(.*\)\..'`; \
559 { test -f $$base.l || test -f $$base.y; } && continue;; \
561 files="$$files $$file"; \
563 grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files \
565 diff -u $@-1 $@-2 || exit 1; \
569 # In a definition of #define AUTHORS "... and ..." where the RHS contains
570 # the English word `and', the string must be marked with `N_ (...)' so that
571 # gettext recognizes it as a string requiring translation.
573 @grep -n '^# *define AUTHORS "[^"]* and ' src/*.c |grep -v ' N_ (' && \
574 { echo '$(ME): enclose the above strings in N_ (...)' 1>&2; \
577 # Sometimes it is useful to change the PATH environment variable
578 # in Makefiles. When doing so, it's better not to use the Unix-centric
579 # path separator of `:', but rather the automake-provided `@PATH_SEPARATOR@'.
580 # It'd be better to use `find -print0 ...|xargs -0 ...', but less portable,
581 # and there probably aren't many projects with so many Makefile.am files
582 # that we'd have to worry about limits on command line length.
583 msg = '$(ME): Do not use `:'\'' above; use @PATH_SEPARATOR@ instead'
584 makefile_path_separator_check:
585 @grep -n 'PATH=.*:' `find $(srcdir) -name Makefile.am` \
586 && { echo $(msg) 1>&2; exit 1; } || :
588 # Check that `make alpha' will not fail at the end of the process.
590 if test -d $(release_archive_dir); then :; else \
591 for file in $(distdir).tar.gz \
592 $(release_archive_dir)/$(distdir).tar.gz; do \
593 test -e $$file || continue; \
595 || { echo ERROR: $$file is not writable; fail=1; }; \
597 test "$$fail" && exit 1 || : ; \
600 v_etc_file = lib/version-etc.c
601 sample-test = tests/sample-test
602 texi = doc/$(PACKAGE).texi
603 # Make sure that the copyright date in $(v_etc_file) is up to date.
604 # Do the same for the $(sample-test) and the main doc/.texi file.
606 @if test -f $(v_etc_file); then \
607 grep 'enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' $(v_etc_file) \
609 || { echo 'out of date copyright in $(v_etc_file); update it' 1>&2; \
612 @if test -f $(sample-test); then \
613 grep '# Copyright (C) '$$(date +%Y)' Free' $(sample-test) \
615 || { echo 'out of date copyright in $(sample-test); update it' 1>&2; \
618 @if test -f $(texi); then \
619 grep 'Copyright @copyright{} .*'$$(date +%Y)' Free' $(texi) \
621 || { echo 'out of date copyright in $(texi); update it' 1>&2; \
626 $(VC) diff > vc-diffs || :
627 if test -s vc-diffs; then \
629 echo "Some files are locally modified:" 1>&2; \
635 cvs-check: vc-diff-check
637 maintainer-distcheck:
642 # Don't make a distribution if checks fail.
643 # Also, make sure the NEWS file is up-to-date.
644 vc-dist: $(local-check) cvs-check maintainer-distcheck
647 # Use this to make sure we don't run these programs when building
648 # from a virgin tgz file, below.
649 null_AM_MAKEFLAGS = \
656 built_programs = $$(cd src && MAKEFLAGS= $(MAKE) -s built_programs.list)
658 warn_cflags = -Dlint -O -Werror -Wall -Wformat -Wshadow -Wpointer-arith
661 write_loser = printf '\#!%s\necho $$0: bad path 1>&2; exit 1\n' '$(SHELL)'
664 t=$(TMPDIR)/$(PACKAGE)/test
667 # Verify that a twisted use of --program-transform-name=PROGRAM works.
668 define install-transform-check
670 $(MAKE) program_transform_name='s/.*/zyx/' \
671 prefix=$(pfx) install \
672 && test "$$(echo $(pfx)/bin/*)" = "$(pfx)/bin/zyx" \
673 && test "$$(echo $(pfx)/share/man/man1/*)" = \
674 "$(pfx)/share/man/man1/zyx.1"
677 # Install, then verify that all binaries and man pages are in place.
678 # Note that neither the binary, ginstall, nor the ].1 man page is installed.
680 $(MAKE) prefix=$(pfx) install \
681 && test ! -f $(pfx)/bin/ginstall \
683 for i in $(built_programs); do \
684 test "$$i" = ginstall && i=install; \
685 for j in "$(pfx)/bin/$$i" \
686 "$(pfx)/share/man/man1/$$i.1"; do \
687 case $$j in *'[.1') continue;; esac; \
689 || { echo "$$j not installed"; fail=1; }; \
692 test $$fail = 1 && exit 1 || :; \
696 # Use -Wformat -Werror to detect format-string/arg-list mismatches.
697 # Also, check for shadowing problems with -Wshadow, and for pointer
698 # arithmetic problems with -Wpointer-arith.
699 # These CFLAGS are pretty strict. If you build this target, you probably
700 # have to have a recent version of gcc and glibc headers.
701 # The hard-linking for-loop below ensures that there is a bin/ directory
702 # full of all of the programs under test (except the ones that are required
703 # for basic Makefile rules), all symlinked to the just-built "false" program.
704 # This is to ensure that if ever a test neglects to make PATH include
705 # the build srcdir, these always-failing programs will run.
706 # Otherwise, it is too easy to test the wrong programs.
707 # Note that "false" itself is a symlink to true, so it too will malfunction.
708 my-distcheck: $(DIST_ARCHIVES) $(local-check)
713 GZIP=$(GZIP_ENV) $(AMTAR) -C $(t) -zxf $(distdir).tar.gz
715 && ./configure --disable-nls \
716 && $(MAKE) CFLAGS='$(warn_cflags)' \
717 AM_MAKEFLAGS='$(null_AM_MAKEFLAGS)' \
719 && $(install-transform-check) \
722 && ($(write_loser)) > $(bin)/loser \
723 && chmod a+x $(bin)/loser \
724 && for i in $(built_programs); do \
726 rm|expr|basename|echo|sort|ls|tr);; \
727 cat|dirname|mv|wc);; \
728 *) ln $(bin)/loser $(bin)/$$i;; \
731 && ln -sf ../src/true $(bin)/false \
732 && PATH=`pwd`/$(bin):$$PATH $(MAKE) -C tests check \
733 && { test -d gnulib-tests \
734 && $(MAKE) -C gnulib-tests check \
738 (cd $(t) && mv $(distdir) $(distdir).old \
739 && $(AMTAR) -zxf - ) < $(distdir).tar.gz
740 diff -ur $(t)/$(distdir).old $(t)/$(distdir)
741 if test -f $(srcdir)/src/c99-to-c89.diff; then \
743 && (cd src && patch -V never --fuzz=0 <c99-to-c89.diff) \
744 && ./configure --disable-largefile \
745 CFLAGS='-Werror -ansi -Wno-long-long' \
749 @echo "========================"; \
750 echo "$(distdir).tar.gz is ready for distribution"; \
751 echo "========================"
757 tarz=/tmp/rel-check-tarz-$$$$; \
758 md5_tmp=/tmp/rel-check-md5-$$$$; \
760 trap 'status=$$?; rm -f $$tarz $$md5_tmp; exit $$status' 0 1 2 3 15; \
761 $(WGET) $(WGETFLAGS) -q --output-document=$$tarz $(url); \
762 echo "$(md5) -" > $$md5_tmp; \
763 md5sum -c $$md5_tmp < $$tarz
765 rel-files = $(DIST_ARCHIVES)
767 gnulib-version = $$(cd $(gnulib_dir) && git describe)
769 announcement: NEWS ChangeLog $(rel-files)
770 @./build-aux/announce-gen \
771 --release-type=$(RELEASE_TYPE) \
772 --package=$(PACKAGE) \
773 --prev=$(PREV_VERSION) \
775 --gpg-key-id=$(gpg_key_ID) \
777 --bootstrap-tools=autoconf,automake,bison,gnulib \
778 --gnulib-version=$(gnulib-version) \
779 $(addprefix --url-dir=, $(url_dir_list))
781 ## ---------------- ##
782 ## Updating files. ##
783 ## ---------------- ##
785 ftp-gnu = ftp://ftp.gnu.org/gnu
786 www-gnu = http://www.gnu.org
788 # Use mv, if you don't have/want move-if-change.
789 move_if_change ?= move-if-change
791 emit_upload_commands:
792 @echo =====================================
793 @echo =====================================
794 @echo "$(srcdir)/build-aux/gnupload $(GNUPLOADFLAGS) \\"
795 @echo " --to $(gnu_rel_host):$(PACKAGE) \\"
796 @echo " $(rel-files)"
797 @echo '# send the /tmp/announcement e-mail'
798 @echo =====================================
799 @echo =====================================
801 noteworthy = * Noteworthy changes in release ?.? (????-??-??) [?]
802 define emit-commit-log
803 printf '%s\n' 'post-release administrivia' '' \
804 '* NEWS: Add header line for next release.' \
805 '* .prev-version: Record previous version.' \
806 '* cfg.mk (old_NEWS_hash): Auto-update.'
809 .PHONY: alpha beta major
810 alpha beta major: $(local-check) writable-files
812 && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$' \
813 || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
816 $(MAKE) news-date-check
817 $(MAKE) -s announcement RELEASE_TYPE=$@ > /tmp/announce-$(my_distdir)
818 if test -d $(release_archive_dir); then \
819 ln $(rel-files) $(release_archive_dir); \
820 chmod a-w $(rel-files); \
822 $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
823 echo $(VERSION) > $(prev_version_file)
824 $(MAKE) update-NEWS-hash
825 perl -pi -e '$$. == 3 and print "$(noteworthy)\n\n\n"' NEWS
826 $(emit-commit-log) > .ci-msg
827 $(VC) commit -F .ci-msg